TestCase subclass: #PrologTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Tests'!

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 09:52'!
testDatabase

	{
		'Family new :? purgeDatabase(brother()).' 
			-> nil.
		'Family new :? database(brother())' 
			-> #(()).
		'Family new :? assertz(brother(''John'', ''Stewart'')),
					asserta(brother(''John'', ''Barbara'')), assertz(brother(''John'', ''Alan'')).'
			-> #(()).
		'Family new :? brother(x,y)'
			->  #(#('John' 'Barbara') #('John' 'Stewart') #('John' 'Alan')).
		'Family new :? retract(brother(''John'', ''Stewart''))'
			-> #(()).
		'Family new :? brother(x,y)'
			->  #(#('John' 'Barbara') #('John' 'Alan')).
		'Family new :? purgeDatabase(brother()).' 
			-> #(()).
	}
	do: [:assoc | self assert: (LCompiler evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 09:20'!
testFamily

	{
		'Family new :? father(x,y)' 
			-> #(('John' 'Mary') ('John' 'David') ('David' 'Jack') ('Arthur' 'Nancy')).
		'Family new :? grandPa(''John'',y)' 
			-> #(('Nancy') ('Jack')).
		'Family new :? father(x, ''Mary'')'
			-> #(('John')).
		'Family new :? grandPa(''John'', x), father(y, x)'
			->  #(('Nancy' 'Arthur') ('Jack' 'David')).
		'Family new :? father(''John'', ''Mary'')'
			-> #(()).
		'Family new :? health(''John'', y)'
			->  #(('John had two times of heart attacks')).
		'Family new :? consult( healthHistory(''John'', x), Doctor new)'
			->  #(('John had two times of heart attacks')).
	}
	do: [:assoc | self assert: (LCompiler evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 12:37'!
testFisherCh2

	| prolog |

	prolog := Chapter2 new.

	{
		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/2_2.html"

		'factorial(3,w)' -> #((6)).
		'factorialT(5,1,f)' -> #((120)).

		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/2_7.html"

		'member(2,[1,2,3])' -> #(()).
		'member(x,[1,2,3])' -> #((1) (2) (3)).
		'member([3,y], [[1,#a],[2,#m],[3,#z],[4,#v],[3,#p]])' -> #((z) (p)).
		'member(x,[23,45,67,12,222,19,9,6]), is(y, x*x), lt(y, 100)'
			-> #((9 81) (6 36)).

"		'takeout(x,[1,2,3],l)' -> #(#(1 [2 3 ]) #(2 [1 3 ]) #(3 [1 2 ]))."
"		'takeout(3,w,[#a,#b,#c])' -> #(#([3 #a #b #c ]) #([#a 3 #b #c ]) #([#a #b 3 #c ]) #([#a #b #c 3 ]))"

	}
	do: [:assoc | 
		self assert: (LCompiler evaluate: 'self yourself :? ', assoc key
						for: prolog logged: false) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 10:52'!
testFisherCh3

	| prolog |

	prolog := Chapter3 new.

	{
		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/3_1.html"

		'eq(p(x,f(y),#a), p(#a,f(#a),y))' -> #((a a)).
		'eq(p(x,f(y),#a),p(#a,f(#b),y))' -> nil.
"		'eq(p(x,f(y),#a) , p(z,f(#b),#a))' ->  #(('Unbound' b 'Unbound'))."
		'eq(p(x,f(y),#a) , p(z,f(#b),#a)), is(x, #d) ' -> #((d b d)).

		"http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/3_2.html"

		'p(x)' -> #((a) (a) (b) (d)).
		'p(x),!!' -> #((a)).
		'r(x),!!,s(y)' -> #((a a) (a b) (a c)).
		'r(x), s(y), !!' -> #((a a)).

		'color(#a,c)' -> #(('red')).
		'color(#c,c)' -> #(('unknown'))
	}
	do: [:assoc | 
		self assert: (LCompiler evaluate: 'self yourself :? ', assoc key
						for: prolog logged: false) = assoc value]! !
