Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!
!Continuation commentStamp: 'spfa 6/18/2006 22:13' prior: 0!
Continuation class borrowed from Seaside
(author: Avi Bryant) !
]style[(62)f1!


!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	values _ valueStream contents! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !


!Continuation methodsFor: 'testing' stamp: 'spfa 6/18/2006 22:14'!
isContinuation

	^ true! !


!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !


!Continuation methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Continuation class
	instanceVariableNames: ''!

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !


PluggableTextMorphWithModel subclass: #REPLMorph
	instanceVariableNames: 'evaluator commandsHistory lastAnswer lastError debugContinuation lastValue queue outputQueueProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

!REPLMorph methodsFor: 'contents' stamp: 'spfa 9/29/2006 10:50'!
acceptTextInModel

	| textToAccept command |

	(self hasProperty: #inCommand)
	ifFalse:
	[
		command _ self currentCommandFor: textMorph contents.
		command ifEmpty: [command _ self pointedCommand].
		(command isNil or: [command isEmpty]) ifTrue: [^ self].
		self insertCommand: command.
	].

	textToAccept := textMorph asText.
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]]
! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 9/28/2006 23:27'!
characterLimit

	"we should be able to set this interactively"

	^ 30000! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/16/2008 13:48'!
evalText: aString

	^ evaluator evalText: aString! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 5/29/2008 15:25'!
freshInput

	| len tlen |

	len _ myContents ifNil: [0] ifNotNil: [myContents size].
	tlen _ textMorph asText size.
	tlen == len ifTrue: [^ ''].

	^ textMorph asText copyFrom: len to: textMorph asText size

! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/7/2006 22:09'!
getMyText
	^myContents! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 5/27/2008 15:19'!
refreshDisplay

	textMorph newContents:  myContents.
	self selectFrom: myContents size + 1 to: myContents size + 1.
	self scrollSelectionIntoView; changed; refreshWorld
! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 5/29/2008 10:55'!
refreshDisplay: freshText

	| fullText |

	fullText _ myContents ifNil: [freshText] 
		ifNotNil: [myContents, freshText].
	textMorph newContents: fullText.
	self selectFrom: fullText size + 1 to: fullText size + 1.
	self scrollSelectionIntoView; refreshWorld.


! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/9/2008 14:58'!
setMyText: text

	| command  |


	(self hasProperty: #inCommand)
	ifTrue:
	[ | psize form |
		psize _ myContents size.
		(psize <= text size) ifTrue:
		[
			text addAttribute: self class commandAttribute
				 from: myContents size + 1 to: text size.
			self updateText: text, String cr.
			form _ text copyFrom: psize to: text size.
			self registerCommand: form asString.
"			lisp standardInput stream nextPutAll: form asString.
			lisp standardInput stream skip: form size negated."
		].
		^ self 
	].

	(command _ self currentCommandFor: text) isEmpty 
	ifFalse: [ 
			self updateText: text, String cr.
	"		[self doCommand: command] fork."
			self doCommand: command
	]
	ifTrue: [self updateText: text ].

! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 9/28/2006 23:22'!
updateText: text

	text size > self characterLimit 
		ifFalse: [^ super setMyText: text].

	 super setMyText: (text copyFrom: text size - self characterLimit to: text size)

! !


!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 6/9/2008 14:51'!
appendEntry

! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/27/2008 23:29'!
clear

	self updateText: '' "self prompt".
	self refreshDisplay: self prompt.! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 6/16/2008 13:48'!
doCommand: aString

	| answer |

	self registerCommand: aString.

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.

	answer :=  [lastAnswer := (self formatAnswer: (lastValue := evaluator evalString: aString)) 
							asText addAttribute: self class answerAttribute]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]].

	self appendEntry; outputQueue.
	self updateText: myContents, answer, String cr.
	self refreshDisplay: self prompt.

! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/29/2008 13:11'!
endEntry

	self appendEntry.
	(outputQueueProcess notNil
		and: [outputQueueProcess isTerminated not]) ifTrue: [^ self].

	outputQueueProcess _ [50 milliSeconds asDelay wait . self outputQueue] fork
! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/27/2008 23:04'!
outputQueue

	| fresh |

	self queue isEmpty ifTrue: [^ self].

	fresh _ self freshInput. 

	self updateText: (Text streamContents: [:stream |
							stream nextPutAll: (myContents ifNil: ['']).
							self queue size timesRepeat: 
								[stream nextPutAll: self queue next]]).

	self refreshDisplay: fresh! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/29/2008 12:36'!
update: aSymbol 

	aSymbol ifNil: [^self].

	aSymbol == #endEntry 
		ifTrue: 
			[self endEntry].

	aSymbol == #appendEntry 
		ifTrue: 
			[self appendEntry].
	aSymbol == #clearText 
		ifTrue: 
			[self clear].
	aSymbol == #force 
		ifTrue: 
			[self outputQueue].! !


!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/31/2008 11:00'!
buildMenu: aMenu

	self commandsHistory do: [:command |
		| str |
		str _ command asString withBlanksTrimmed.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str].

	lastAnswer ifNotNil: [
		| str |
		str _ lastAnswer asString withBlanksTrimmed.
		aMenu addLine.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str;
				add: 'explore last value' target: lastValue selector: #explore].

	commandsHistory isEmpty ifTrue:
		[aMenu add: 'no history yet' action: #yourself]
	ifFalse:
		[
			aMenu addLine;
			add: 'display history' action: #displayHistory
		].

	debugContinuation ifNotNil: [
		aMenu addLine.
		aMenu add: (('DEBUG ', lastError) truncateWithElipsisTo: 70)
			 target: debugContinuation selector: #value].

	^ aMenu! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/7/2006 23:44'!
commandsHistory

	^ commandsHistory ifNil: [commandsHistory _ OrderedCollection new]
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 10/3/2006 10:39'!
currentCommandFor: text

	| lastLinePos lastLine  |

	lastLinePos _ text lastIndexOfSubCollection: (String cr, self prompt asString withoutTrailingBlanks)  ifAbsent: [0].
"	lastLinePos _ text lastIndexOf: Character cr ifAbsent: [ 0 ]."
	lastLinePos _ text asString skipAnySubStr: {self prompt asString withoutTrailingBlanks} startingAt: lastLinePos + 1.
	lastLine _ text copyFrom: lastLinePos to: text size.
	^ lastLine asString withBlanksTrimmed! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 15:11'!
displayHistory

	(Workspace new contents: (String streamContents: [:str |
		self commandsHistory do: [:command |
			str nextPutAll: command; cr]])) 
		openLabel: 'commands history'
	! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/16/2008 12:50'!
formatAnswer: anObject

	anObject ifNil: [^ 'No.'].
	anObject = #(()) ifTrue: [^ 'Yes'].

	^ String streamContents: [:str |
		anObject do: [:elt |
			elt size = 1 ifTrue: [elt first printOn: str]
				ifFalse: [elt printOn: str].
			str cr].
		str skip: -1]

	

	

	! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 15:02'!
insertCommand: aString

	textMorph newContents: (Text streamContents: [:str |

		str nextPutAll: (myContents ifNil: ['']).

		(self hasProperty: #inCommand) ifFalse: [
			myContents isEmptyOrNil ifFalse: [
				myContents last == Character cr ifFalse: [str cr]].
			str nextPutAll: self prompt].

		str nextPutAll:((Text fromString: aString) 
							addAttribute: self class commandAttribute)]).

	textMorph editor selectAt: textMorph asText size + 1! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 14:36'!
insertNextCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command _ commandsHistory first).
	commandsHistory removeFirst.
	commandsHistory addLast: command! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 14:37'!
insertPreviousCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command _ commandsHistory last).
	commandsHistory removeLast.
	commandsHistory addFirst: command! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/8/2006 13:55'!
pointedCommand

	| beg end text line prompt |

	text _ textMorph contents asString.
	end _ (text indexOf: Character cr startingAt: selectionInterval last ifAbsent: [text size + 1]) - 1.
	
	beg _ text lastIndexOf: Character cr startingAt: end ifAbsent: [0].
	line _ text asString copyFrom: beg + 1 to: end.
	prompt  _ self prompt asString withoutTrailingBlanks.

	(line beginsWith: prompt) ifFalse: [^ nil].

	^ (line copyFrom: (line skipAnySubStr: {prompt} startingAt: 1) to: line size)
			withBlanksTrimmed! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 13:16'!
registerCommand: aString

	self commandsHistory remove: aString ifAbsent: [].
	commandsHistory addFirst: aString.
	commandsHistory size > self class historyLength
		 ifTrue: [commandsHistory removeLast].
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/18/2006 22:06'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/18/2006 22:06'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !


!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/16/2008 13:47'!
evaluator: anObject

	evaluator := anObject.

	self appendEntry; outputQueue.
	self refreshDisplay: self prompt

! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/9/2008 14:53'!
initialize
	super initialize.
	self extent: 600@400.
	self color: Color white.
	self acceptOnCR: true.
	getMenuSelector _ #buildMenu:.



	! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/16/2008 13:47'!
prompt
	
	^ evaluator prompt, ' '! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 9/28/2006 22:43'!
queue

	^ queue ifNil: [queue _ SharedQueue new]! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/16/2008 13:43'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/18/2006 23:05'!
wantsFrameAdornments

	^ false! !


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

REPLMorph class
	instanceVariableNames: ''!

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:01'!
answerAttribute

	^ TextColor color: Color gray darker! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:12'!
commandAttribute

	^ TextColor color: Color blue muchDarker! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:01'!
displayAttribute

	^ TextColor color: Color red muchDarker muchDarker! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 10/2/2006 09:53'!
displayFont

	^ (TextStyle named: #Accumon) 
		fontOfSize: TextStyle defaultFont pointSize! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/18/2006 22:26'!
errorAttribute

	^ TextColor color: Color red! !


!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2006 14:11'!
historyLength

	^ 30! !

!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 13:46'!
on: anObject

	^ self new evaluator: anObject! !


PluggableTextMorph subclass: #REPLPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 20:23'!
buildMenu: aMenu

	model buildMenu: aMenu.
	^ aMenu! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 13:43'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:55'!
spawn! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 21:32'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 21:31'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

REPLPluggableTextMorph class
	instanceVariableNames: ''!

!REPLPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:31'!
mayHaveVignette

	^ true! !

!REPLPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:31'!
newPage

	^ (MGraphPluggableTextMorph on: MGraphWorkspace new
			text: #contents
			accept: #acceptContents:
			readSelection: nil 
			menu: #codePaneMenu:shifted:)
		color: (Color white alpha: 0.9)! !


TextMorphEditor subclass: #REPLTextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:30'!
cursorPageDown: characterStream 

	self isOnPromptLine
		ifTrue: [model insertNextCommand. ^ true].

	^ super cursorPageDown: characterStream ! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:30'!
cursorPageUp: characterStream 

	self isOnPromptLine
		ifTrue: [model insertPreviousCommand. ^ true].

	^ super cursorPageUp: characterStream ! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:17'!
encompassLine: anInterval
	"Return an interval that encompasses the entire line, minus the promt if present at the beginning"

	| string left right |
	string _ paragraph text string.
	left _ (string lastIndexOf: Character cr startingAt: anInterval first - 1 ifAbsent:[0]) + 1.

	left == 
		(string indexOfSubCollection: model prompt startingAt: left ifAbsent: [nil]) 
	ifTrue: [left _ left + model prompt size].

	right _ (string indexOf: Character cr startingAt: anInterval last + 1 ifAbsent: [string size + 1]) - 1.
	^left to: right! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 15:16'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"

	self lineSelectAndEmptyCheck: [^ ''].
	^ model evalString: self selectionAsStream contents asString! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:25'!
isOnPromptLine

	^ self isPromptLine: self selectionInterval
! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:24'!
isPromptLine: anInterval

	| string left |
	string _ paragraph text string.
	left _ (string lastIndexOf: Character cr startingAt: anInterval first - 1 ifAbsent:[0]) + 1.

	^ left == 
		(string indexOfSubCollection: model prompt startingAt: left ifAbsent: [nil]) 
! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 15:16'!
printIt
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	| result |
	result _ self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [self afterSelectionInsertAndSelect: (result printString)]! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:25'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^PositionableStream
		on: paragraph string
		from: self startIndex
		to: self stopIndex - 1! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:54'!
spawn

	! !


TextMorphForEditView subclass: #REPLTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 13:43'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	editor := REPLTextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 14:38'!
keyStroke: evt
	
"	editView lisp standardInput stream nextPut: evt keyCharacter."
	super keyStroke: evt! !
